<template>
  <section class="p-4 my-4">
    <div v-if="service">
      <h1>Servizio {{ service["title"] }}</h1>
      <div v-if="service['deprecated']" class="chip chip-danger chip-lg chip-simple">
        <span class="chip-label">Deprecato</span>
      </div>
      <p v-if="service['description']" class="font-italic">{{ service["description"] }}</p>
      <div class="my-5" v-if="service">

      </div>
    </div>
    <div v-else-if="errorMessage" class="alert alert-danger">
      <p>{{ errorMessage }}</p>
    </div>
    <div class="my-5 alert alert-info" v-if="!service && !loading">
      Non sono presenti servizi
    </div>
    <div id="formio"></div>
    <div class="d-flex justify-content-end" v-if="service">
      <button type="button" class="btn btn-outline-primary mx-3" @click="editForm">Modifica</button>
      <button type="button" class="btn btn-outline-secondary" @click="deleteForm()">Elimina</button>
    </div>
  </section>
  <section v-if="loading">
    <div class="justify-content-center d-flex mb-3">
      <div class="progress-spinner progress-spinner-active">
        <span class="sr-only">Caricamento...</span>
      </div>
    </div>
  </section>
</template>

<script>

import axios from "axios";
import router from "@/router/router";

const i18n = require("../i18n");

export default {
  name: "Service",
  data() {
    return {
      service: null,
      errorMessage: "",
      loading: false
    };
  },
  methods: {
    getService() {
      this.loading = true;
      axios.get(`/api/form/${this.$route.params.id}`)
          .then((result) => {
            this.service = result.data;
            // eslint-disable-next-line no-undef
            Formio.setBaseUrl(window.location.protocol + "//" + window.location.hostname + "/api");
            setTimeout(() => {
              // eslint-disable-next-line no-undef
              Formio.createForm(document.getElementById("formio"), this.service, {
                i18n,
              });
              this.loading = false;
            }, 2000)
          }, () => {
            this.errorMessage = "Non è stato possibile recuperare il servizio";
            this.loading = false;
          });
    },
    deleteForm() {
      const shouldDelete = confirm("Sei sicuro di voler eliminare il form?");
      if (shouldDelete) {
        axios.delete(`/api/form/${this.$route.params.id}`)
            .then(() => {
              router.push("/services");
            }, () => {
              this.errorMessage = "Non è stato possibile eliminare il servizio";
            });
      }
    },
    editForm() {
      router.push({
        path: "/builder",
        query: {id: this.service._id}
      });
    },
  },
  mounted() {
    this.getService();
  },
};

</script>
